//LCD Functions for 4 & 8 bit modes

//LCD Module Connections
extern bit RS;                                                                   
extern bit EN;                           
extern bit D4;
extern bit D5;
extern bit D6;
extern bit D7;
//End LCD Module Connections 


void Lcd_Delay(int a)
{
    int j;
    int i;
    for(i=0;i<a;i++)
    {
        for(j=0;j<100;j++)
        {
        }
    }
}



//LCD 4 Bit Interfacing Functions

void Lcd_Port(char a)
{
	if(a & 1)
		D4 = 1;
	else 
		D4 = 0;
	
	if(a & 2)
		D5 = 1;
	else
		D5 = 0;
	
	if(a & 4)
		D6 = 1;
	else
		D6 = 0;
	
	if(a & 8)
		D7 = 1;
	else
		D7 = 0;
}
void Lcd_Cmd(char a)
{ 
	RS = 0;             // => RS = 0
	Lcd_Port(a);
	EN  = 1;             // => E = 1
  Lcd_Delay(5);
  EN  = 0;             // => E = 0
}

Lcd_Clear()
{
	Lcd_Cmd(0);
	Lcd_Cmd(1);
}

void Lcd_Set_Cursor(char a, char b)
{
	char temp,z,y;
	if(a == 1)
	{
	  temp = 0x80 + b;
		z = temp>>4;
		y = (0x80+b) & 0x0F;
		Lcd_Cmd(z);
		Lcd_Cmd(y);
	}
	else if(a == 2)
	{
		temp = 0xC0 + b;
		z = temp>>4;
		y = (0xC0+b) & 0x0F;
		Lcd_Cmd(z);
		Lcd_Cmd(y);
	}
}

void Lcd_Init()
{
	Lcd_Port(0x00);
	Lcd_Delay(200);
	///////////// Reset process from datasheet /////////
  Lcd_Cmd(0x03);
	Lcd_Delay(50);
  Lcd_Cmd(0x03);
	Lcd_Delay(110);
  Lcd_Cmd(0x03);
  /////////////////////////////////////////////////////
  Lcd_Cmd(0x02);    
	Lcd_Cmd(0x02);
  Lcd_Cmd(0x08); 	
	Lcd_Cmd(0x00); 
	Lcd_Cmd(0x0C);     
  Lcd_Cmd(0x00);    
  Lcd_Cmd(0x06);   
}

void Lcd_Write_Char(char a)
{
   char temp,y;
   temp = a&0x0F; 
   y = a&0xF0;	
	 RS = 1;             // Register Select = 1
   Lcd_Port(y>>4);             //Data transfer
	 EN = 1;
	 Lcd_Delay(5);
	 EN = 0;
	 Lcd_Port(temp);
	 EN = 1;
	 Lcd_Delay(5);
	 EN = 0;
}

void Lcd_Write_String(char *a)
{
	int i;
	for(i=0;a[i]!='\0';i++)
	 Lcd_Write_Char(a[i]);
}

void Lcd_Shift_Right()
{
	Lcd_Cmd(0x01);
	Lcd_Cmd(0x0C);
}

void Lcd_Shift_Left()
{
	Lcd_Cmd(0x01);
	Lcd_Cmd(0x08);
}
//End LCD 4 Bit Interfacing Functions
